
package org.visnow.vn.applications;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.WindowConstants;
import org.visnow.vn.application.application.Application;
import org.visnow.vn.engine.Engine;
import org.visnow.vn.engine.core.CoreName;
import org.visnow.vn.engine.core.Link;
import org.visnow.vn.engine.core.ModuleCore;
import org.visnow.vn.engine.main.ModuleBox;
import org.visnow.vn.system.main.VisNow;

/**
 *
 * @author know
 */
public class ApplicationTemplate extends javax.swing.JFrame
{
    protected Application application = new Application("viewer");
    protected Engine engine = application.getEngine();
    
    protected final void initModule(String name, ModuleCore core)
    {
        try {
            core.setHideGUIwhenNoData(false);
            core.setApplication(application);
            ModuleBox mb = new ModuleBox(engine, name, core);
            engine.getModules().put(name, mb);
            mb.run();
            core.onInitFinished();
        } catch (Exception e) {
        }
    }

    protected ModuleCore addModule(String name, String classDesc)
    {
        try {
            ModuleCore core = application.getLibraries().generateCore(new CoreName("internal", classDesc));
            initModule(name, core);
            return core;
        } catch (Exception e) {
            return null;
        }
    }

    protected final void newModule(String name, String classDesc)
    {
        modulePane.addTab(name, addModule(name, classDesc).getPanel());
    }

    protected final Link addLink(String source, String sourcePort, String target, String targetPort)
    {
        try {
            return new Link(engine.getModule(source).getOutput(sourcePort),
                            engine.getModule(target).getInput(targetPort));
        } catch (Exception e) {
            return null;
        }
    }

    /**
     * Creates new form ApplicationTemplate
     */
    public ApplicationTemplate()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        jSplitPane1 = new JSplitPane();
        modulePane = new JTabbedPane();
        mainPanel = new JPanel();

        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setMinimumSize(new Dimension(1240, 800));
        setPreferredSize(new Dimension(1500, 900));
        getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.LINE_AXIS));

        modulePane.setBorder(BorderFactory.createEtchedBorder());
        modulePane.setMaximumSize(new Dimension(300, 1200));
        modulePane.setMinimumSize(new Dimension(220, 800));
        modulePane.setPreferredSize(new Dimension(240, 900));
        jSplitPane1.setLeftComponent(modulePane);

        mainPanel.setBackground(new Color(204, 204, 204));
        mainPanel.setBorder(BorderFactory.createEtchedBorder());
        mainPanel.setMinimumSize(new Dimension(800, 800));
        mainPanel.setLayout(new BorderLayout());
        jSplitPane1.setRightComponent(mainPanel);

        getContentPane().add(jSplitPane1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        VisNow.mainBlocking(args, false);
        new ApplicationTemplate().setVisible(true);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private JSplitPane jSplitPane1;
    protected JPanel mainPanel;
    protected JTabbedPane modulePane;
    // End of variables declaration//GEN-END:variables
}
